local mkbi_curr_target = ""
local mkbi_start_health_per = 0
local mkbi_save_possible = false
mkbi_save_startime = nil

function MontsKBIndicator.BuildSave()
    mkbi_saveframe:SetFontSize(MKBISave.mainsize)
	mkbi_saveframe:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.savex,MKBISave.savey)
	mkbi_saveframe:SetWordwrap(false)
	mkbi_saveframe:SetLayer(1)
	mkbi_saveframe:SetFont("MontsKBIndicator",MKBISave.savefont)
	mkbi_saveframe:SetFontColor(0,0.7,0,1)
	mkbi_saveframe:SetVisible(false)
	mkbi_saveframe:SetText("You Saved")
    
    mkbi_savename:SetFontSize(MKBISave.namesize)
	mkbi_savename:SetFontColor(0.7,0.7,0,1)
	mkbi_savename:SetPoint("CENTER",mkbi_saveframe,"CENTER",0,mkbi_saveframe:GetHeight()+10)
	mkbi_savename:SetWordwrap(false)
	mkbi_savename:SetLayer(1)
	mkbi_savename:SetFont("MontsKBIndicator",MKBISave.savefont)
	mkbi_savename:SetVisible(false)
	mkbi_savename:SetText("")
end

function MontsKBIndicator.IDoneHealedSomeone(hEvent,mkbi_heal)
    if mkbi_heal and MKBISave.enable_saves then
        if mkbi_heal.caster then
           if mkbi_heal.caster == mkbi_playerid then
                if mkbi_heal.target then
                    local mkbi_target_info = Inspect.Unit.Detail(mkbi_heal.target)
                    if mkbi_target_info then
                        if mkbi_target_info.player and mkbi_target_info.combat then
                            if mkbi_heal.heal then
                                local mkbi_target_health = mkbi_target_info.health
                                local mkbi_target_healthMax = mkbi_target_info.healthMax
                                local mkbi_amount_healed = mkbi_heal.heal
                                if ((mkbi_target_health - mkbi_amount_healed)/mkbi_target_healthMax) < 0.3 and mkbi_target_health/mkbi_target_healthMax >= 0.3 then
                                    if mkbi_textframe:GetVisible() then
                                        MontsKBIndicator.HideKBText()
                                    end
                                    mkbi_save_startime = Inspect.Time.Real()
                                    MontsKBIndicator.ShowSaveText(mkbi_heal.targetName)
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

function MontsKBIndicator.ShowSaveText(mkbi_tar_name)
    mkbi_saveframe:ClearAll()
    mkbi_savename:ClearAll()
    MontsKBIndicator.BuildSave()
    mkbi_savename:SetText(mkbi_tar_name)
    mkbi_savename:SetPoint("CENTER",mkbi_saveframe,"CENTER",0,mkbi_saveframe:GetHeight()+10)
    mkbi_savename:SetVisible(true)
    mkbi_saveframe:SetVisible(true)
end

Command.Event.Attach(Event.Combat.Heal,MontsKBIndicator.IDoneHealedSomeone,"Healing Happened")