mkbi_last_dmg_type = ""

function MontsKBIndicator.GetLastDamageType(hEvent,mkbi_dmg)
    if mkbi_dmg then
        if mkbi_dmg.caster == mkbi_playerid and mkbi_dmg.target ~= mkbi_playerid then
            if mkbi_dmg.type then
                mkbi_last_dmg_type = mkbi_dmg.type
            -- Added because some physical attacks seemed to be using water, type might be nonexistant for physical attacks
            else
                mkbi_last_dmg_type = "none"
            end 
        end
    end
end

function MontsKBIndicator.SetMessageToType()
    local mkbi_rng = math.random()
    if mkbi_last_dmg_type == "life" then
        if mkbi_rng < 0.33 then
            mkbi_textframe:SetText("You Just Mauled")
        elseif mkbi_rng <0.66 and mkbi_rng >= 0.33 then
            mkbi_textframe:SetText("You Choked")
        else
            mkbi_textframe:SetText("You Overran")
        end
    elseif mkbi_last_dmg_type == "earth" then
        if mkbi_rng < 0.33 then
            mkbi_textframe:SetText("You Crushed")
        elseif mkbi_rng <0.66 and mkbi_rng >= 0.33 then
            mkbi_textframe:SetText("You Dusted")
        else
            mkbi_textframe:SetText("You Ground")
        end
    elseif mkbi_last_dmg_type == "death" then
        if mkbi_rng < 0.33 then
            mkbi_textframe:SetText("You Annihilated")
        elseif mkbi_rng <0.66 and mkbi_rng >= 0.33 then
            mkbi_textframe:SetText("You Have Ended")
        else
            mkbi_textframe:SetText("You Have Ruined")
        end
    elseif mkbi_last_dmg_type == "air" then
        if mkbi_rng < 0.33 then
            mkbi_textframe:SetText("You Blew Over")
        elseif mkbi_rng <0.66 and mkbi_rng >= 0.33 then
            mkbi_textframe:SetText("You Have Blasted")
        else
            mkbi_textframe:SetText("You Have Expelled")
        end
    elseif mkbi_last_dmg_type == "water" then
        if mkbi_rng < 0.33 then
            mkbi_textframe:SetText("You Drowned")
        elseif mkbi_rng <0.66 and mkbi_rng >= 0.33 then
            mkbi_textframe:SetText("You Flowed Over")
        else
            mkbi_textframe:SetText("You Dragged Down")
        end
    elseif mkbi_last_dmg_type == "fire" then
        if mkbi_rng < 0.33 then
            mkbi_textframe:SetText("You Incinerated")
        elseif mkbi_rng <0.66 and mkbi_rng >= 0.33 then
            mkbi_textframe:SetText("You Cooked")
        else
            mkbi_textframe:SetText("You Have Melted")
        end
    else
        mkbi_textframe:SetText("You Have Killed")
    end
end

Command.Event.Attach(Event.Combat.Damage,MontsKBIndicator.GetLastDamageType,"Determining the damage done")