-- Background image source http://lulztroll87.deviantart.com/art/Skull-Border-329335822

-- Globals
mkbi_currently_testing = false

-- General frames
local mkbi_edit_ui = UI.CreateFrame("Texture","Edit UI",mkbi_ui)
local mkbi_textframe_edit = UI.CreateFrame("Text","Main Text Frame",mkbi_ui)
local mkbi_nametext_edit = UI.CreateFrame("Text","Name Text Frame",mkbi_ui)
local mkbi_xptext_edit = UI.CreateFrame("Text","Experience Text Frame",mkbi_ui)
local mkbi_patext_edit = UI.CreateFrame("Text","PA Experience Text Frame",mkbi_ui)
local mkbi_favor_edit = UI.CreateFrame("Text","Favor Text Frame",mkbi_ui)
local mkbi_prestige_edit = UI.CreateFrame("Text","Prestige Text Frame",mkbi_ui)
local mkbi_edit_button = UI.CreateFrame("Texture","Edit UI Button",mkbi_ui)
local mkbi_edit_ui_close = UI.CreateFrame("RiftButton","Edit UI Button Close",mkbi_ui)
local mkbi_reset_button = UI.CreateFrame("RiftButton","Reset Button",mkbi_ui)
local mkbi_specmsg_chbox = UI.CreateFrame("RiftCheckbox","Special Message Checkbox",mkbi_ui)
local mkbi_specmsg_label = UI.CreateFrame("Text","Special Message Label",mkbi_ui)
local mkbi_move_button = UI.CreateFrame("RiftButton","Move the Text Button",mkbi_ui)
local mkbi_save_chbox = UI.CreateFrame("RiftCheckbox","Enable Saves Checkbox",mkbi_ui)
local mkbi_save_label = UI.CreateFrame("Text","Enable Saves Label",mkbi_ui)
local mkbi_uptime_scroll = UI.CreateFrame("RiftScrollbar","Up Time Scrollbar",mkbi_ui)
local mkbi_uptime_edit = UI.CreateFrame("RiftTextfield","Up Time Text Field",mkbi_ui)
local mkbi_uptime_label = UI.CreateFrame("Text","Up Time Label",mkbi_ui)
local mkbi_test_button = UI.CreateFrame("RiftButton","Test Settings Button",mkbi_ui)
local mkbi_kb_tab = UI.CreateFrame("Frame","Killing Blow Tab",mkbi_ui)
local mkbi_save_tab = UI.CreateFrame("Frame", "Save Tab",mkbi_ui)
local mkbi_accolade_tab = UI.CreateFrame("Frame","Accolade Tab",mkbi_ui)
local mkbi_kb_tab_text = UI.CreateFrame("Text","KB Tab Text",mkbi_ui)
local mkbi_save_tab_text = UI.CreateFrame("Text","Save Tab Text",mkbi_ui)
local mkbi_accolade_tab_text = UI.CreateFrame("Text","Accolade Tab Text",mkbi_ui)
local mkbi_moveframe = UI.CreateFrame("Frame","Moveable Frame",mkbi_ui)
local mkbi_savemoveframe = UI.CreateFrame("Frame","Save Moveable Frame",mkbi_ui)

-- Frames for selecting fonts with menu open boolean
local mkbi_font_dropbox = UI.CreateFrame("Texture","Font Dropbox",mkbi_ui)
local mkbi_font_selector = UI.CreateFrame("Frame","Font Selection Frame",mkbi_ui)
local mkbi_font_sel_text = UI.CreateFrame("Text","Font Selection Text",mkbi_ui)
local mkbi_font_sel_label = UI.CreateFrame("Text","Font Selection Label",mkbi_ui)
local mkbi_font_menu_open = false

-- Frames for selecting the textfield to edit with menu open boolean and currently selected textfield for editing string
local mkbi_textfield_dropbox = UI.CreateFrame("Texture","Textfield Dropbox",mkbi_ui)
local mkbi_textfield_selector = UI.CreateFrame("Frame","Textfield Selection Frame",mkbi_ui)
local mkbi_textfield_text = UI.CreateFrame("Text","Textfield Selection Text",mkbi_ui)
local mkbi_textfield_sel_label = UI.CreateFrame("Text","Textfield Selection Label",mkbi_ui)
local mkbi_textfield_menu_open = false
local mkbi_current_textfield = "Main"

-- Frames for editing text size and color
local mkbi_text_edit_size = UI.CreateFrame("RiftTextfield","Size Edit Field",mkbi_ui)
local mkbi_text_size_scroll = UI.CreateFrame("RiftScrollbar","Text Size Scrollbar",mkbi_ui)
local mkbi_text_edit_red = UI.CreateFrame("RiftTextfield","Text Color Red",mkbi_ui)
local mkbi_text_red_scroll = UI.CreateFrame("RiftScrollbar","Text Red Scrollbar",mkbi_ui)
local mkbi_text_edit_green = UI.CreateFrame("RiftTextfield","Text Color Green",mkbi_ui)
local mkbi_text_green_scroll = UI.CreateFrame("RiftScrollbar","Text Green Scrollbar",mkbi_ui)
local mkbi_text_edit_blue = UI.CreateFrame("RiftTextfield","Text Color Green",mkbi_ui)
local mkbi_text_blue_scroll = UI.CreateFrame("RiftScrollbar","Text Blue Scrollbar",mkbi_ui)
local mkbi_size_label = UI.CreateFrame("Text","Size Label",mkbi_ui)
local mkbi_text_red_label = UI.CreateFrame("Text","Red Label",mkbi_ui)
local mkbi_text_green_label = UI.CreateFrame("Text","Green Label",mkbi_ui)
local mkbi_text_blue_label = UI.CreateFrame("Text","Blue Label",mkbi_ui)

-- Booleans for moving frames and offsets for the edit text (just moves mkbi_textframe_ui then all other frames since they are anchored
-- to mkbi_textframe_ui
local mkbi_button_rightdown = false
local mkbi_ui_rightdown = false
local mkbi_text_yoffset = 175
local mkbi_text_xoffset = 550
local mkbi_current_tab = "killing blow"

-- Frame arrays for the font drop down menu
local mkbi_font_frames = {}
local mkbi_font_text_frames = {}
-- Frame arrays for the textfield drop down menu
local mkbi_textfield_frames = {}
local mkbi_textfield_text_frames = {}

-- File Name = Font Name
local mkbi_fonts = {
                 ["AngloSaxon"] = "Anglo Saxon",
                 ["Bard"] = "Bard",
                 ["Blackcha"] = "Black Chancery",
              --   ["brothers_of_metal"]= "Brothers Of Metal",
                 ["Cas_antn"]= "Caslon Antique",
                 ["Casanti"]= "Caslon Antique Italic",
                 ["celticmd"]= "Celtic",
                 ["DANIELA"]= "Daniela",
                 ["DARK11"]= "Dark11",
                 ["demonpriest"]= "Demon Priest",
                 ["demonpriestcondital"]= "Demon Priest Italic",
                 ["dpquake"]= "Quake",
                 ["Dragon_Master"]= "Dragon Master",
                 ["ENDOR"]= "Endor",
                 ["FiddumsFamily"]= "Fiddums Family",
                 ["GALLA"]= "Gallaecia",
                 ["grimghost"]= "Grim Ghost",
                 ["HARNGTON"]= "Harrington",
                 ["hobbiton"]= "Hobbiton",
                 ["Kingdom_Hearts"]= "Kingdom Hearts",
                 ["KingthingsXander"]= "King Things Xander",
                 ["KnightsQuest"]= "Knight's Quest",
                 ["NITEMARE"]= "Nitemare",
                 ["Soul_of_Holitter"]= "Soul Of Holitter",
                 ["Tolky"]= "Tolky",
                 ["VIKING"]= "Viking",
                 ["VTCGoblinHand"]= "VTC Goblin Hand",
                 ["zombiecontrol"]= "Zombie Control",
                 ["celexa"] = "Celexa", -- NEW 12/26/2013
                 ["Face Your Fears"] = "Face Your Fears", -- NEW
                 ["Halo"] = "Halo", -- NEW
                 ["Mostwasted"] = "Most Wasted", -- NEW
                 ["Silent Hill E"] = "Silent Hill" -- NEW
}

-- The textfields that can be edited
local mkbi_textfields = {
                 "Main",
                 "Name",
                 "XP",
                 "PA XP",
                 "Favor",
                 "Prestige"
}
local mkbi_save_textfields = {
				"Main",
				"Name"
}


-- Build the Edit UI, but only show the edit button
function MontsKBIndicator.BuildEditUI()
    mkbi_textframe_edit:SetVisible(false)
    mkbi_nametext_edit:SetVisible(false)
    mkbi_xptext_edit:SetVisible(false)
    mkbi_patext_edit:SetVisible(false)
    mkbi_favor_edit:SetVisible(false)
    mkbi_prestige_edit:SetVisible(false)
    mkbi_edit_ui:SetVisible(false)
    mkbi_edit_ui_close:SetVisible(false)
    mkbi_reset_button:SetVisible(false)
    mkbi_specmsg_chbox:SetVisible(false)
    mkbi_specmsg_label:SetVisible(false)
    mkbi_move_button:SetVisible(false)
    mkbi_uptime_scroll:SetVisible(false)
    mkbi_uptime_edit:SetVisible(false)
    mkbi_uptime_label:SetVisible(false)
    mkbi_save_chbox:SetVisible(false)
    mkbi_save_label:SetVisible(false)
    mkbi_test_button:SetVisible(false)
    mkbi_kb_tab:SetVisible(false)
    mkbi_save_tab:SetVisible(false)
    mkbi_accolade_tab:SetVisible(false)
    mkbi_kb_tab_text:SetVisible(false)
    mkbi_save_tab_text:SetVisible(false)
    mkbi_accolade_tab_text:SetVisible(false)
    
    mkbi_edit_button:SetPoint("CENTER",mkbi_ui,"CENTER",MKBISave.buttonx, MKBISave.buttony)
    mkbi_edit_button:SetTexture("MontsKBIndicator","MKBI Button.png")
    mkbi_edit_button:SetLayer(0)
    mkbi_edit_button:SetWidth(30)
    mkbi_edit_button:SetHeight(30)
    mkbi_edit_button:SetVisible(true)
    mkbi_edit_button:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.EditUIShow() end,"Show Edit UI")
    mkbi_edit_button:EventAttach(Event.UI.Input.Mouse.Right.Down,function()
        mkbi_button_rightdown = true
        local mkbi_mouse = Inspect.Mouse()
        mkbi_edit_button.originalXDiff = mkbi_mouse.x - mkbi_edit_button:GetLeft()
		mkbi_edit_button.originalYDiff = mkbi_mouse.y - mkbi_edit_button:GetTop()
        end,"MKBI Button RightDown")
    mkbi_edit_button:EventAttach(Event.UI.Input.Mouse.Right.Up,function () if mkbi_edit_button.fixedPos then
			return
		end mkbi_button_rightdown = false end, "MKBI Button RightUp")
    mkbi_edit_button:EventAttach(Event.UI.Input.Mouse.Right.Upoutside,function() mkbi_button_rightdown = false end, "MKBI Button RightUpOutside")
    mkbi_edit_button:EventAttach(Event.UI.Input.Mouse.Cursor.Move,function(mkbi_edit_button,hEvent,x,y)
        if not mkbi_button_rightdown then
			return
		end
		local newX = x - mkbi_edit_button.originalXDiff
		local newY = y - mkbi_edit_button.originalYDiff
		mkbi_edit_button:SetPoint("CENTER", mkbi_ui, "CENTER", newX, newY)
		MKBISave.buttonx = newX
		MKBISave.buttony = newY
		end,"Button Mouse Move")
    
    mkbi_edit_ui:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.editx, MKBISave.edity)
    mkbi_edit_ui:SetLayer(1)
    mkbi_edit_ui:SetTexture("MontsKBIndicator","MKBI Edit UI.jpg")
    mkbi_edit_ui:SetWidth(1050)
    mkbi_edit_ui:EventAttach(Event.UI.Input.Mouse.Right.Down,function()
        mkbi_ui_rightdown = true
        local mkbi_mouse = Inspect.Mouse()
        mkbi_edit_ui.originalXDiff = mkbi_mouse.x - mkbi_edit_ui:GetLeft()
		mkbi_edit_ui.originalYDiff = mkbi_mouse.y - mkbi_edit_ui:GetTop()
        end,"MKBI Button RightDown")
    mkbi_edit_ui:EventAttach(Event.UI.Input.Mouse.Right.Up,function () mkbi_ui_rightdown = false end, "MKBI Edit UI RightUp")
    mkbi_edit_ui:EventAttach(Event.UI.Input.Mouse.Right.Upoutside,function() mkbi_ui_rightdown = false end, "MKBI Edit UI RightUpOutside")
    mkbi_edit_ui:EventAttach(Event.UI.Input.Mouse.Cursor.Move,function(mkbi_edit_ui,hEvent,x,y)
        if not mkbi_ui_rightdown then
			return
		end
		local newX = x - mkbi_edit_ui.originalXDiff
		local newY = y - mkbi_edit_ui.originalYDiff
		mkbi_edit_ui:SetPoint("TOPLEFT", mkbi_ui, "TOPLEFT", newX, newY)
		MKBISave.editx = newX
		MKBISave.edity = newY
		end,"Edit UI Mouse Move")
	
	mkbi_moveframe:SetHeight(100)
	mkbi_moveframe:SetWidth(100)
	mkbi_moveframe:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,MKBISave.y)
	mkbi_moveframe:SetLayer(9)
	mkbi_moveframe:SetBackgroundColor(1,1,1,0.6)
	mkbi_moveframe:SetVisible(false)
	
	mkbi_moveframe:EventAttach(Event.UI.Input.Mouse.Left.Down,function(mkbi_moveframe,hEvent)
		if mkbi_moveframe.fixedPos then
			return
		end
		mkbi_moveframe.leftDown = true
		local mouse = Inspect.Mouse()
		mkbi_moveframe.originalXDiff = mouse.x - mkbi_moveframe:GetLeft()
		mkbi_moveframe.originalYDiff = mouse.y - mkbi_moveframe:GetTop()
		local left, top, right, bottom = mkbi_moveframe:GetBounds()
	end,"LeftDown")
	
    mkbi_moveframe:EventAttach(Event.UI.Input.Mouse.Left.Up,function (mkbi_moveframe,hEvent)
		if not mkbi_moveable then
			return
		end
		mkbi_moveframe.leftDown = false
	end,"LeftUp")
	
	mkbi_moveframe:EventAttach(Event.UI.Input.Mouse.Left.Upoutside,function(mkbi_moveframe,hEvent)
		if not mkbi_moveable then
			return
		end
		mkbi_moveframe.leftDown = false
	end,"LeftUpOutside")
	
	mkbi_moveframe:EventAttach(Event.UI.Input.Mouse.Cursor.Move,function(mkbi_moveframe,hEvent,x,y)
		if not mkbi_moveable then
			return
		end
		if not mkbi_moveframe.leftDown then
			return
		end
		local newX = x - mkbi_moveframe.originalXDiff
		local newY = y - mkbi_moveframe.originalYDiff
		mkbi_moveframe:SetPoint("TOPLEFT", mkbi_ui, "TOPLEFT", newX, newY)
		mkbi_textframe:SetPoint("TOPLEFT", mkbi_ui, "TOPLEFT", newX, newY)
		MKBISave.x = newX
		MKBISave.y = newY
	end,"MouseMove")
	
	mkbi_moveframe:EventAttach(Event.UI.Input.Mouse.Right.Down,function()
		if not mkbi_moveable then
			return
		end
		mkbi_moveable = false
		mkbi_moveframe:SetVisible(false)
		MontsKBIndicator.HideKBText()
		MontsKBIndicator.EditUIShow()
	end,"RightDown")
	
	mkbi_savemoveframe:SetHeight(100)
	mkbi_savemoveframe:SetWidth(100)
	mkbi_savemoveframe:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.savex,MKBISave.savey)
	mkbi_savemoveframe:SetLayer(9)
	mkbi_savemoveframe:SetBackgroundColor(1,1,1,0.6)
	mkbi_savemoveframe:SetVisible(false)
	
	mkbi_savemoveframe:EventAttach(Event.UI.Input.Mouse.Left.Down,function(mkbi_savemoveframe,hEvent)
		if mkbi_savemoveframe.fixedPos then
			return
		end
		mkbi_savemoveframe.leftDown = true
		local mouse = Inspect.Mouse()
		mkbi_savemoveframe.originalXDiff = mouse.x - mkbi_savemoveframe:GetLeft()
		mkbi_savemoveframe.originalYDiff = mouse.y - mkbi_savemoveframe:GetTop()
		local left, top, right, bottom = mkbi_savemoveframe:GetBounds()
	end,"LeftDown")
	
    mkbi_savemoveframe:EventAttach(Event.UI.Input.Mouse.Left.Up,function (mkbi_savemoveframe,hEvent)
		if not mkbi_moveable then
			return
		end
		mkbi_savemoveframe.leftDown = false
	end,"LeftUp")
	
	mkbi_savemoveframe:EventAttach(Event.UI.Input.Mouse.Left.Upoutside,function(mkbi_savemoveframe,hEvent)
		if not mkbi_moveable then
			return
		end
		mkbi_savemoveframe.leftDown = false
	end,"LeftUpOutside")
	
	mkbi_savemoveframe:EventAttach(Event.UI.Input.Mouse.Cursor.Move,function(mkbi_savemoveframe,hEvent,x,y)
		if not mkbi_moveable then
			return
		end
		if not mkbi_savemoveframe.leftDown then
			return
		end
		local newX = x - mkbi_savemoveframe.originalXDiff
		local newY = y - mkbi_savemoveframe.originalYDiff
		mkbi_savemoveframe:SetPoint("TOPLEFT", mkbi_ui, "TOPLEFT", newX, newY)
		mkbi_saveframe:SetPoint("TOPLEFT", mkbi_ui, "TOPLEFT", newX, newY)
		MKBISave.savex = newX
		MKBISave.savey = newY
	end,"MouseMove")
	
	mkbi_savemoveframe:EventAttach(Event.UI.Input.Mouse.Right.Down,function()
		if not mkbi_moveable then
			return
		end
		mkbi_moveable = false
		mkbi_savemoveframe:SetVisible(false)
		mkbi_savename:SetVisible(false)
		mkbi_saveframe:SetVisible(false)
		MontsKBIndicator.EditUIShow()
	end,"RightDown")
    
    mkbi_edit_ui_close:SetLayer(2)
    mkbi_edit_ui_close:SetSkin("close")
    mkbi_edit_ui_close:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",mkbi_edit_ui:GetWidth()-mkbi_edit_ui_close:GetWidth(),0)
    mkbi_edit_ui_close:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.EditUIHide() end,"Hide Edit UI")
    
    mkbi_reset_button:SetLayer(2)
    mkbi_reset_button:SetEnabled(true)
    mkbi_reset_button:SetSkin("default")
    mkbi_reset_button:SetText("RESET")
    mkbi_reset_button:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",400,mkbi_edit_ui:GetHeight()- mkbi_reset_button:GetHeight()-50)
    mkbi_reset_button:EventAttach(Event.UI.Button.Left.Press,function () MontsKBIndicator.ResetToDefault() end, "Reset Button Clicked")
    
    mkbi_specmsg_chbox:SetLayer(2)
    mkbi_specmsg_chbox:SetEnabled(true)
    mkbi_specmsg_chbox:SetWidth(30)
    mkbi_specmsg_chbox:SetHeight(30)
    mkbi_specmsg_chbox:SetChecked(MKBISave.specialmsg)
    mkbi_specmsg_chbox:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",600,mkbi_edit_ui:GetHeight() - mkbi_specmsg_chbox:GetHeight()-50)
    mkbi_specmsg_chbox:EventAttach(Event.UI.Checkbox.Change,function () MontsKBIndicator.SpecialMsgCheckboxHandler() end, "Message Checkbox Change")
    
    mkbi_save_chbox:SetLayer(2)
    mkbi_save_chbox:SetEnabled(true)
    mkbi_save_chbox:SetWidth(30)
    mkbi_save_chbox:SetHeight(30)
    mkbi_save_chbox:SetChecked(MKBISave.enable_saves)
    mkbi_save_chbox:SetPoint("TOPLEFT",mkbi_specmsg_chbox,"TOPLEFT",0,-mkbi_save_chbox:GetHeight())
    mkbi_save_chbox:EventAttach(Event.UI.Checkbox.Change,function () MontsKBIndicator.EnableSavesCheckboxHandler() end, "Enable Saves Checkbox Change")
    
    mkbi_specmsg_label:SetLayer(2)
    mkbi_specmsg_label:SetFontColor(1,0,0,1)
    mkbi_specmsg_label:SetFontSize(20)
    mkbi_specmsg_label:SetText("Adapt Message To Damage Type")
    mkbi_specmsg_label:SetPoint("TOPRIGHT",mkbi_specmsg_chbox,"TOPRIGHT",mkbi_specmsg_label:GetWidth(),0)
    
    mkbi_save_label:SetLayer(2)
    mkbi_save_label:SetFontColor(1,0,0,1)
    mkbi_save_label:SetFontSize(20)
    mkbi_save_label:SetText("Enable Saves")
    mkbi_save_label:SetPoint("TOPRIGHT",mkbi_save_chbox,"TOPRIGHT",mkbi_save_label:GetWidth(),0)
    
    mkbi_move_button:SetLayer(2)
    mkbi_move_button:SetEnabled(true)
    mkbi_move_button:SetSkin("default")
    mkbi_move_button:SetText("Move")
    mkbi_move_button:SetPoint("TOPLEFT",mkbi_reset_button,"TOPLEFT",-mkbi_move_button:GetWidth()-50,0)
    mkbi_move_button:EventAttach(Event.UI.Button.Left.Press,function () MontsKBIndicator.MoveButtonHandler() end, "Move Button Clicked")
    
    mkbi_test_button:SetLayer(2)
    mkbi_test_button:SetEnabled(true)
    mkbi_test_button:SetSkin("default")
    mkbi_test_button:SetText("Test")
    mkbi_test_button:SetPoint("TOPLEFT",mkbi_move_button,"TOPLEFT",-mkbi_test_button:GetWidth()-50,0)
    mkbi_test_button:EventAttach(Event.UI.Button.Left.Press,function () MontsKBIndicator.TestSettings() end, "Test Settings Clicked")
    
    mkbi_kb_tab:SetLayer(2)
    mkbi_kb_tab:SetWidth(200)
    mkbi_kb_tab:SetHeight(50)
    mkbi_kb_tab:SetBackgroundColor(1,0.4,0.4,1)
    mkbi_kb_tab:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",0,-mkbi_kb_tab:GetHeight())
    mkbi_kb_tab:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.TabHandler(mkbi_kb_tab) end,"KB Select")
    
    mkbi_kb_tab_text:SetLayer(3)
    mkbi_kb_tab_text:SetFontSize(25)
    mkbi_kb_tab_text:SetFont("MontsKBIndicator","Fonts/zombiecontrol.ttf")
    mkbi_kb_tab_text:SetText("Killing Blows")
    mkbi_kb_tab_text:SetEffectGlow({blurX = 10, blurY = 10,strength = 5})
    mkbi_kb_tab_text:SetPoint("CENTER",mkbi_kb_tab,"CENTER",0,0)
    
    mkbi_save_tab:SetLayer(2)
    mkbi_save_tab:SetWidth(200)
    mkbi_save_tab:SetHeight(50)
    mkbi_save_tab:SetBackgroundColor(0.6,1,0.2,1)
    mkbi_save_tab:SetPoint("TOPLEFT",mkbi_kb_tab,"TOPRIGHT",0,0)
    mkbi_save_tab:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.TabHandler(mkbi_save_tab) end,"Save Select")
    
    mkbi_save_tab_text:SetLayer(3)
    mkbi_save_tab_text:SetFontSize(25)
    mkbi_save_tab_text:SetFont("MontsKBIndicator","Fonts/zombiecontrol.ttf")
    mkbi_save_tab_text:SetText("Saves")
    mkbi_save_tab_text:SetEffectGlow(nil)
    mkbi_save_tab_text:SetPoint("CENTER",mkbi_save_tab,"CENTER",0,0)
    
    MontsKBIndicator.BuildUIText()
    MontsKBIndicator.BuildMenuItems()
end

-- Build the Text for the edit UI.  Done seperatly since this will need to be called many times as the user edits.
function MontsKBIndicator.BuildUIText()
	if mkbi_current_tab == "killing blow" then
		mkbi_textframe_edit:SetLayer(2)
		mkbi_textframe_edit:SetFont("MontsKBIndicator",MKBISave.font)
		mkbi_textframe_edit:SetFontSize(MKBISave.mainsize)
		mkbi_textframe_edit:SetFontColor(MKBISave.mainred,MKBISave.maingreen,MKBISave.mainblue,MKBISave.alpha)
		mkbi_textframe_edit:SetText("You Have Killed")
		mkbi_textframe_edit:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",mkbi_text_xoffset,mkbi_text_yoffset)
		
		-- Center all other frames on mkbi_text_frame
		mkbi_nametext_edit:SetLayer(2)
		mkbi_nametext_edit:SetFont("MontsKBIndicator",MKBISave.font)
		mkbi_nametext_edit:SetFontSize(MKBISave.namesize)
		mkbi_nametext_edit:SetFontColor(MKBISave.namered,MKBISave.namegreen,MKBISave.nameblue,MKBISave.alpha)
		mkbi_nametext_edit:SetText("Thatguy@Server")
		mkbi_nametext_edit:SetPoint("CENTER",mkbi_textframe_edit,"CENTER",0,mkbi_textframe_edit:GetHeight()+10)
		if MKBISave.font == "Fonts/celticmd.ttf" then
			mkbi_nametext_edit:SetPoint("CENTER",mkbi_textframe_edit,"CENTER",0,mkbi_textframe_edit:GetHeight()+(mkbi_nametext_edit:GetHeight()/2))
		end
		mkbi_xptext_edit:SetLayer(2)
		mkbi_xptext_edit:SetFont("MontsKBIndicator",MKBISave.font)
		mkbi_xptext_edit:SetFontSize(MKBISave.xpsize)
		mkbi_xptext_edit:SetFontColor(MKBISave.xpred,MKBISave.xpgreen,MKBISave.xpblue,MKBISave.alpha)
		mkbi_xptext_edit:SetText("123 XP")
		mkbi_xptext_edit:SetPoint("CENTER",mkbi_nametext_edit,"CENTER",0,mkbi_nametext_edit:GetHeight())
		
		mkbi_patext_edit:SetLayer(2)
		mkbi_patext_edit:SetFont("MontsKBIndicator",MKBISave.font)
		mkbi_patext_edit:SetFontSize(MKBISave.pasize)
		mkbi_patext_edit:SetFontColor(MKBISave.pared,MKBISave.pagreen,MKBISave.pablue,MKBISave.alpha)
		mkbi_patext_edit:SetText("456 PA XP")
		mkbi_patext_edit:SetPoint("CENTER",mkbi_xptext_edit,"CENTER",0,mkbi_xptext_edit:GetHeight())
		
		mkbi_favor_edit:SetLayer(2)
		mkbi_favor_edit:SetFont("MontsKBIndicator",MKBISave.font)
		mkbi_favor_edit:SetFontSize(MKBISave.favsize)
		mkbi_favor_edit:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
		mkbi_favor_edit:SetText("789 Favor")
		mkbi_favor_edit:SetPoint("CENTER",mkbi_patext_edit,"CENTER",0,mkbi_patext_edit:GetHeight())
		
		mkbi_prestige_edit:SetLayer(2)
		mkbi_prestige_edit:SetFont("MontsKBIndicator",MKBISave.font)
		mkbi_prestige_edit:SetFontSize(MKBISave.pressize)
		mkbi_prestige_edit:SetFontColor(MKBISave.presred,MKBISave.presgreen,MKBISave.presblue,MKBISave.alpha)
		mkbi_prestige_edit:SetText("0 Prestige")
		mkbi_prestige_edit:SetPoint("CENTER",mkbi_favor_edit,"CENTER",0,mkbi_favor_edit:GetHeight())
	elseif mkbi_current_tab == "saves" then
		mkbi_textframe_edit:SetLayer(2)
		mkbi_textframe_edit:SetFont("MontsKBIndicator",MKBISave.savefont)
		mkbi_textframe_edit:SetFontSize(MKBISave.savemainsize)
		mkbi_textframe_edit:SetFontColor(MKBISave.savemainred,MKBISave.savemaingreen,MKBISave.savemainblue,MKBISave.savealpha)
		mkbi_textframe_edit:SetText("You Have Saved")
		mkbi_textframe_edit:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",mkbi_text_xoffset,mkbi_text_yoffset)
		
		mkbi_nametext_edit:SetLayer(2)
		mkbi_nametext_edit:SetFont("MontsKBIndicator",MKBISave.savefont)
		mkbi_nametext_edit:SetFontSize(MKBISave.savenamesize)
		mkbi_nametext_edit:SetFontColor(MKBISave.savenamered,MKBISave.savenamegreen,MKBISave.savenameblue,MKBISave.savealpha)
		mkbi_nametext_edit:SetText("Thatguy@Server")
		mkbi_nametext_edit:SetPoint("CENTER",mkbi_textframe_edit,"CENTER",0,mkbi_textframe_edit:GetHeight()+10)
		if MKBISave.font == "Fonts/celticmd.ttf" then
			mkbi_nametext_edit:SetPoint("CENTER",mkbi_textframe_edit,"CENTER",0,mkbi_textframe_edit:GetHeight()+(mkbi_nametext_edit:GetHeight()/2))
		end
		mkbi_xptext_edit:SetVisible(false)
		mkbi_patext_edit:SetVisible(false)
		mkbi_favor_edit:SetVisible(false)
		mkbi_prestige_edit:SetVisible(false)
		
	elseif mkbi_current_tab == "accolades" then
	
	end
end

function MontsKBIndicator.BuildMenuItems()
    -- Font drop down menu frames
    mkbi_font_dropbox:SetVisible(false)
    mkbi_font_selector:SetVisible(false)
    mkbi_font_sel_text:SetVisible(false)
    mkbi_textfield_selector:SetVisible(false)
    mkbi_textfield_dropbox:SetVisible(false)
    mkbi_textfield_text:SetVisible(false)
    mkbi_font_sel_label:SetVisible(false)
    mkbi_textfield_sel_label:SetVisible(false)
    mkbi_text_edit_size:SetVisible(false)
    mkbi_text_size_scroll:SetVisible(false)
    mkbi_size_label:SetVisible(false)
    mkbi_text_red_scroll:SetVisible(false)
    mkbi_text_green_scroll:SetVisible(false)
    mkbi_text_blue_scroll:SetVisible(false)
    mkbi_text_edit_red:SetVisible(false)
    mkbi_text_edit_green:SetVisible(false)
    mkbi_text_edit_blue:SetVisible(false)
    mkbi_text_red_label:SetVisible(false)
    mkbi_text_green_label:SetVisible(false)
    mkbi_text_blue_label:SetVisible(false)
    
    -- This also sets the width for the drop down menu frames
    mkbi_font_selector:SetLayer(2)
    mkbi_font_selector:SetBackgroundColor(0,0,0,1)
    mkbi_font_selector:SetWidth(150)
    mkbi_font_selector:SetHeight(45)
    mkbi_font_selector:SetPoint("TOPLEFT",mkbi_edit_ui,"TOPLEFT",100,100)
    
    mkbi_font_dropbox:SetLayer(2)
    mkbi_font_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
    mkbi_font_dropbox:SetPoint("TOPLEFT",mkbi_font_selector,"TOPLEFT",mkbi_font_selector:GetWidth(),0)
    mkbi_font_dropbox:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.FontMenuHandler() end,"Font Menu")
    
    mkbi_font_sel_text:SetLayer(3)
    mkbi_font_sel_text:SetFontColor(1,1,1,1)
    mkbi_font_sel_text:SetFontSize(16)
    mkbi_font_sel_text:SetPoint("CENTER",mkbi_font_selector,"CENTER",0,0)
    local mkbi_filename_text,_ = string.gsub(MKBISave.font,".ttf","")
    mkbi_filename_text,_ = string.gsub(mkbi_filename_text,"Fonts/","")
    for mkbi_fontfile,mkbi_text_toset in pairs(mkbi_fonts) do
        if mkbi_fontfile == mkbi_filename_text then
            mkbi_filename_text = mkbi_text_toset
            break
        end
    end
    mkbi_font_sel_text:SetText(mkbi_filename_text)
    
    mkbi_font_sel_label:SetLayer(2)
    mkbi_font_sel_label:SetFontColor(0,0,0,1)
    mkbi_font_sel_label:SetFontSize(20)
    mkbi_font_sel_label:SetText("Select Font")
    mkbi_font_sel_label:SetPoint("CENTER",mkbi_font_selector,"CENTER",0,-(mkbi_font_selector:GetHeight()/2 + mkbi_font_sel_label:GetHeight()/2))
    
    -- Textfield drop down menu frames
    mkbi_textfield_selector:SetLayer(2)
    mkbi_textfield_selector:SetBackgroundColor(0,0,0,1)
    mkbi_textfield_selector:SetWidth(150)
    mkbi_textfield_selector:SetHeight(45)
    mkbi_textfield_selector:SetPoint("TOPLEFT",mkbi_font_selector,"TOPLEFT",0,100)
    
    mkbi_textfield_dropbox:SetLayer(2)
    mkbi_textfield_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
    mkbi_textfield_dropbox:SetPoint("TOPLEFT",mkbi_textfield_selector,"TOPLEFT",mkbi_textfield_selector:GetWidth(),0)
    mkbi_textfield_dropbox:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.TextfieldMenuHandler() end,"Textfield Menu")
    
    mkbi_textfield_text:SetLayer(3)
    mkbi_textfield_text:SetFontColor(1,1,1,1)
    mkbi_textfield_text:SetFontSize(16)
    mkbi_textfield_text:SetPoint("CENTER",mkbi_textfield_selector,"CENTER",0,0)
    mkbi_textfield_text:SetText("Main")
    
    mkbi_textfield_sel_label:SetLayer(2)
    mkbi_textfield_sel_label:SetFontColor(0,0,0,1)
    mkbi_textfield_sel_label:SetFontSize(20)
    mkbi_textfield_sel_label:SetPoint("CENTER",mkbi_textfield_selector,"CENTER",0,-(mkbi_textfield_selector:GetHeight()/2+mkbi_textfield_selector:GetHeight()/4))
    mkbi_textfield_sel_label:SetText("Textfield To Edit")
    
    -- Text Size Field
    mkbi_text_size_scroll:SetLayer(2)
    mkbi_text_size_scroll:SetOrientation("vertical")
    mkbi_text_size_scroll:SetRange(20,50)
    mkbi_text_size_scroll:SetWidth(20)
    mkbi_text_size_scroll:SetHeight(275)
    --mkbi_text_size_scroll:SetPosition(1)
    mkbi_text_size_scroll:SetEnabled(true)
    mkbi_text_size_scroll:SetPoint("TOPLEFT",mkbi_textfield_selector,"TOPLEFT",0,145)
    mkbi_text_size_scroll:EventAttach(Event.UI.Scrollbar.Change,function() MontsKBIndicator.SizeScrollbarHandler() end,"Scrollbar Change")
    
    mkbi_text_edit_size:SetWidth(30)
    mkbi_text_edit_size:SetHeight(20)
    mkbi_text_edit_size:SetLayer(2)
    mkbi_text_edit_size:SetBackgroundColor(0,0,0,1)
    mkbi_text_edit_size:SetText(tostring(MKBISave.mainsize))
    mkbi_text_edit_size:SetPoint("CENTER",mkbi_text_size_scroll,"CENTER",0,-(mkbi_text_size_scroll:GetHeight()/2+mkbi_text_edit_size:GetHeight()))
    mkbi_text_edit_size:EventAttach(Event.UI.Textfield.Change,function() MontsKBIndicator.SizeTextHandler() end, "Size Text Change")
    
    mkbi_size_label:SetLayer(2)
    mkbi_size_label:SetFontColor(0,0,0,1)
    mkbi_size_label:SetFontSize(20)
    mkbi_size_label:SetText("Size")
    mkbi_size_label:SetPoint("CENTER",mkbi_text_edit_size,"CENTER",0,-mkbi_text_edit_size:GetHeight())
    
    -- Gap between the scroll bars while they're vertical (make it easier to reset gap if horizontal bug is ever fixed)
    local mkbi_scroll_offset = 56
    
    mkbi_text_red_scroll:SetLayer(2)
    mkbi_text_red_scroll:SetWidth(20)
    mkbi_text_red_scroll:SetHeight(275)
    mkbi_text_red_scroll:SetEnabled(true)
    mkbi_text_red_scroll:SetOrientation("vertical")
    mkbi_text_red_scroll:SetPoint("TOPLEFT",mkbi_text_size_scroll,"TOPLEFT",mkbi_scroll_offset,0)
    mkbi_text_red_scroll:EventAttach(Event.UI.Scrollbar.Change,function() MontsKBIndicator.RedScrollbarHandler() end, "Red Scrollbar Change")
    
    mkbi_text_edit_red:SetLayer(2)
    mkbi_text_edit_red:SetWidth(30)
    mkbi_text_edit_red:SetHeight(20)
    mkbi_text_edit_red:SetBackgroundColor(0,0,0,1)
    mkbi_text_edit_red:SetText(tostring(MKBISave.mainred*255))
    mkbi_text_edit_red:SetPoint("CENTER",mkbi_text_red_scroll,"CENTER",0,-(mkbi_text_red_scroll:GetHeight()/2+mkbi_text_edit_red:GetHeight()))
    mkbi_text_edit_red:EventAttach(Event.UI.Textfield.Change,function() MontsKBIndicator.RedTextHandler() end, "Red Textfield Change")
    
    mkbi_text_red_label:SetLayer(2)
    mkbi_text_red_label:SetFontColor(1,0,0,1)
    mkbi_text_red_label:SetFontSize(20)
    mkbi_text_red_label:SetText("Red")
    mkbi_text_red_label:SetPoint("CENTER",mkbi_text_edit_red,"CENTER",0,-mkbi_text_edit_red:GetHeight())
    
    mkbi_text_green_scroll:SetLayer(2)
    mkbi_text_green_scroll:SetWidth(20)
    mkbi_text_green_scroll:SetHeight(275)
    mkbi_text_green_scroll:SetEnabled(true)
    mkbi_text_green_scroll:SetOrientation("vertical")
    mkbi_text_green_scroll:SetPoint("TOPLEFT",mkbi_text_red_scroll,"TOPLEFT",mkbi_scroll_offset,0)
    mkbi_text_green_scroll:EventAttach(Event.UI.Scrollbar.Change,function() MontsKBIndicator.GreenScrollbarHandler() end, "Green Scrollbar Change")
    
    mkbi_text_edit_green:SetLayer(2)
    mkbi_text_edit_green:SetWidth(30)
    mkbi_text_edit_green:SetHeight(20)
    mkbi_text_edit_green:SetBackgroundColor(0,0,0,1)
    mkbi_text_edit_green:SetText(tostring(MKBISave.maingreen*255))
    mkbi_text_edit_green:SetPoint("CENTER",mkbi_text_green_scroll,"CENTER",0,-(mkbi_text_green_scroll:GetHeight()/2+mkbi_text_edit_green:GetHeight()))
    mkbi_text_edit_green:EventAttach(Event.UI.Textfield.Change,function() MontsKBIndicator.GreenTextHandler() end, "Green Textfield Change")
    
    mkbi_text_green_label:SetLayer(2)
    mkbi_text_green_label:SetFontColor(0,1,0,1)
    mkbi_text_green_label:SetFontSize(20)
    mkbi_text_green_label:SetText("Green")
    mkbi_text_green_label:SetPoint("CENTER",mkbi_text_edit_green,"CENTER",0,-mkbi_text_edit_green:GetHeight())
    
    mkbi_text_blue_scroll:SetLayer(2)
    mkbi_text_blue_scroll:SetWidth(20)
    mkbi_text_blue_scroll:SetHeight(275)
    mkbi_text_blue_scroll:SetEnabled(true)
    mkbi_text_blue_scroll:SetOrientation("vertical")
    mkbi_text_blue_scroll:SetPoint("TOPLEFT",mkbi_text_green_scroll,"TOPLEFT",mkbi_scroll_offset,0)
    mkbi_text_blue_scroll:EventAttach(Event.UI.Scrollbar.Change,function() MontsKBIndicator.BlueScrollbarHandler() end, "Blue Scrollbar Change")
    
    mkbi_text_edit_blue:SetLayer(2)
    mkbi_text_edit_blue:SetWidth(30)
    mkbi_text_edit_blue:SetHeight(20)
    mkbi_text_edit_blue:SetBackgroundColor(0,0,0,1)
    mkbi_text_edit_blue:SetText(tostring(MKBISave.mainblue*255))
    mkbi_text_edit_blue:SetPoint("CENTER",mkbi_text_blue_scroll,"CENTER",0,-(mkbi_text_blue_scroll:GetHeight()/2+mkbi_text_edit_blue:GetHeight()))
    mkbi_text_edit_blue:EventAttach(Event.UI.Textfield.Change,function() MontsKBIndicator.BlueTextHandler() end, "Blue Textfield Change")
    
    mkbi_text_blue_label:SetLayer(2)
    mkbi_text_blue_label:SetFontColor(0,0,1,1)
    mkbi_text_blue_label:SetFontSize(20)
    mkbi_text_blue_label:SetText("Blue")
    mkbi_text_blue_label:SetPoint("CENTER",mkbi_text_edit_blue,"CENTER",0,-mkbi_text_edit_blue:GetHeight())
    
    mkbi_uptime_scroll:SetLayer(2)
    mkbi_uptime_scroll:SetWidth(20)
    mkbi_uptime_scroll:SetHeight(465)
    mkbi_uptime_scroll:SetEnabled(true)
    mkbi_uptime_scroll:SetOrientation("vertical")
    mkbi_uptime_scroll:SetPoint("TOPLEFT",mkbi_text_blue_scroll,"TOPLEFT",mkbi_scroll_offset,mkbi_text_blue_scroll:GetHeight() - mkbi_uptime_scroll:GetHeight())
    mkbi_uptime_scroll:EventAttach(Event.UI.Scrollbar.Change,function() MontsKBIndicator.UpTimeScrollHandler() end, "Up Time Scrollbar Change")
    
    mkbi_uptime_edit:SetLayer(2)
    mkbi_uptime_edit:SetWidth(30)
    mkbi_uptime_edit:SetHeight(20)
    mkbi_uptime_edit:SetBackgroundColor(0,0,0,1)
    mkbi_uptime_edit:SetText(tostring(MKBISave.uptime))
    mkbi_uptime_edit:SetPoint("CENTER",mkbi_uptime_scroll,"CENTER",0,-(mkbi_uptime_scroll:GetHeight()/2+mkbi_uptime_edit:GetHeight()))
    mkbi_uptime_edit:EventAttach(Event.UI.Textfield.Change,function() MontsKBIndicator.UpTimeTextHandler() end, "Up Time Textfield Change")
    
    mkbi_uptime_label:SetLayer(2)
    mkbi_uptime_label:SetFontColor(0,0,0,1)
    mkbi_uptime_label:SetFontSize(20)
    mkbi_uptime_label:SetText("Time")
    mkbi_uptime_label:SetPoint("CENTER",mkbi_uptime_edit,"CENTER",0,-mkbi_uptime_edit:GetHeight())
    
end

function MontsKBIndicator.EditUIShow()
    mkbi_textframe_edit:SetVisible(true)
    mkbi_nametext_edit:SetVisible(true)
    mkbi_xptext_edit:SetVisible(true)
    mkbi_patext_edit:SetVisible(true)
    mkbi_favor_edit:SetVisible(true)
    mkbi_prestige_edit:SetVisible(true)
    mkbi_edit_ui:SetVisible(true)
    mkbi_edit_ui_close:SetVisible(true)
    mkbi_font_dropbox:SetVisible(true)
    mkbi_font_sel_text:SetVisible(true)
    mkbi_font_selector:SetVisible(true)
    mkbi_textfield_selector:SetVisible(true)
    mkbi_textfield_dropbox:SetVisible(true)
    mkbi_textfield_text:SetVisible(true)
    mkbi_font_sel_label:SetVisible(true)
    mkbi_textfield_sel_label:SetVisible(true)
    mkbi_text_edit_size:SetVisible(true)
    mkbi_text_size_scroll:SetVisible(true)
    mkbi_size_label:SetVisible(true)
    mkbi_text_red_scroll:SetVisible(true)
    mkbi_text_green_scroll:SetVisible(true)
    mkbi_text_blue_scroll:SetVisible(true)
    mkbi_text_edit_red:SetVisible(true)
    mkbi_text_edit_green:SetVisible(true)
    mkbi_text_edit_blue:SetVisible(true)
    mkbi_text_red_label:SetVisible(true)
    mkbi_text_green_label:SetVisible(true)
    mkbi_text_blue_label:SetVisible(true)
    mkbi_reset_button:SetVisible(true)
    mkbi_specmsg_chbox:SetVisible(true)
    mkbi_specmsg_label:SetVisible(true)
    mkbi_move_button:SetVisible(true)
    mkbi_uptime_scroll:SetVisible(true)
    mkbi_uptime_edit:SetVisible(true)
    mkbi_uptime_label:SetVisible(true)
    mkbi_save_chbox:SetVisible(true)
    mkbi_save_label:SetVisible(true)
    mkbi_test_button:SetVisible(true)
    mkbi_kb_tab:SetVisible(true)
    mkbi_kb_tab_text:SetVisible(true)
    mkbi_save_tab:SetVisible(true)
    mkbi_save_tab_text:SetVisible(true)
    
    local mkbi_uptime_scrollbar_fix = MKBISave.uptime
    mkbi_uptime_scroll:SetRange(0.1,15)
    mkbi_uptime_scroll:SetPosition(MKBISave.uptime)
    
    local mkbi_size_scrollbar_reset_fix = 0
	local mkbi_red_scrollbar_fix = 0
	local mkbi_green_scrollbar_fix = 0
	local mkbi_blue_scrollbar_fix = 0
	if mkbi_current_tab == "killing blow" then
		mkbi_size_scrollbar_reset_fix = MKBISave.mainsize
		mkbi_text_size_scroll:SetRange(10,50)
		mkbi_text_size_scroll:SetPosition(mkbi_size_scrollbar_reset_fix)
		
		mkbi_red_scrollbar_fix = MKBISave.mainred
		mkbi_text_red_scroll:SetRange(0,255)
		mkbi_text_red_scroll:SetPosition(mkbi_red_scrollbar_fix*255)
		
		mkbi_green_scrollbar_fix = MKBISave.maingreen
		mkbi_text_green_scroll:SetRange(0,255)
		mkbi_text_green_scroll:SetPosition(mkbi_green_scrollbar_fix*255)
		
		mkbi_blue_scrollbar_fix = MKBISave.mainblue
		mkbi_text_blue_scroll:SetRange(0,255)
		mkbi_text_blue_scroll:SetPosition(mkbi_blue_scrollbar_fix*255)
	elseif mkbi_current_tab == "saves" then
		mkbi_size_scrollbar_reset_fix = MKBISave.savemainsize
		mkbi_text_size_scroll:SetRange(10,50)
		mkbi_text_size_scroll:SetPosition(mkbi_size_scrollbar_reset_fix)
		
		mkbi_red_scrollbar_fix = MKBISave.savemainred
		mkbi_text_red_scroll:SetRange(0,255)
		mkbi_text_red_scroll:SetPosition(mkbi_red_scrollbar_fix*255)
		
		mkbi_green_scrollbar_fix = MKBISave.savemaingreen
		mkbi_text_green_scroll:SetRange(0,255)
		mkbi_text_green_scroll:SetPosition(mkbi_green_scrollbar_fix*255)
		
		mkbi_blue_scrollbar_fix = MKBISave.savemainblue
		mkbi_text_blue_scroll:SetRange(0,255)
		mkbi_text_blue_scroll:SetPosition(mkbi_blue_scrollbar_fix*255)
	elseif mkbi_current_tab == "accolades" then
			
	end
end

function MontsKBIndicator.EditUIHide()
    mkbi_textframe_edit:SetVisible(false)
    mkbi_nametext_edit:SetVisible(false)
    mkbi_xptext_edit:SetVisible(false)
    mkbi_patext_edit:SetVisible(false)
    mkbi_favor_edit:SetVisible(false)
    mkbi_prestige_edit:SetVisible(false)
    mkbi_edit_ui:SetVisible(false)
    mkbi_edit_ui_close:SetVisible(false)
    mkbi_font_dropbox:SetVisible(false)
    mkbi_font_sel_text:SetVisible(false)
    mkbi_font_selector:SetVisible(false)
    mkbi_textfield_selector:SetVisible(false)
    mkbi_textfield_dropbox:SetVisible(false)
    mkbi_textfield_text:SetVisible(false)
    mkbi_font_sel_label:SetVisible(false)
    mkbi_text_edit_size:SetVisible(false)
    mkbi_textfield_sel_label:SetVisible(false)
    mkbi_text_size_scroll:SetVisible(false)
    mkbi_size_label:SetVisible(false)
    mkbi_text_red_scroll:SetVisible(false)
    mkbi_text_green_scroll:SetVisible(false)
    mkbi_text_blue_scroll:SetVisible(false)
    mkbi_text_edit_red:SetVisible(false)
    mkbi_text_edit_green:SetVisible(false)
    mkbi_text_edit_blue:SetVisible(false)
    mkbi_text_red_label:SetVisible(false)
    mkbi_text_green_label:SetVisible(false)
    mkbi_text_blue_label:SetVisible(false)
    mkbi_reset_button:SetVisible(false)
    mkbi_specmsg_chbox:SetVisible(false)
    mkbi_specmsg_label:SetVisible(false)
    mkbi_move_button:SetVisible(false)
    mkbi_moveframe:SetVisible(false)
    mkbi_uptime_scroll:SetVisible(false)
    mkbi_uptime_edit:SetVisible(false)
    mkbi_uptime_label:SetVisible(false)
    mkbi_save_chbox:SetVisible(false)
    mkbi_save_label:SetVisible(false)
    mkbi_test_button:SetVisible(false)
    mkbi_kb_tab:SetVisible(false)
    mkbi_kb_tab_text:SetVisible(false)
    mkbi_save_tab:SetVisible(false)
    mkbi_save_tab_text:SetVisible(false)
    
    mkbi_moveable = false
    
    for i=1,table.maxn(mkbi_font_frames),1 do
        mkbi_font_frames[i]:SetVisible(false)
        mkbi_font_text_frames[i]:SetVisible(false)
    end
    for i=1,table.maxn(mkbi_textfield_frames),1 do
        mkbi_textfield_frames[i]:SetVisible(false)
        mkbi_textfield_text_frames[i]:SetVisible(false)
    end
    mkbi_textfield_text:SetText("Main")
    mkbi_current_textfield = "Main"
end

function MontsKBIndicator.FontMenuHandler()
    -- If the Textfield menu is open close it
    if mkbi_textfield_menu_open then
    mkbi_textfield_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
        for i=1,table.maxn(mkbi_textfield_frames),1 do
            mkbi_textfield_frames[i]:SetVisible(false)
            mkbi_textfield_text_frames[i]:SetVisible(false)
        end
        mkbi_textfield_menu_open = false
    end
    if mkbi_font_menu_open then
        mkbi_font_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
        for i=1,table.maxn(mkbi_font_frames),1 do
            mkbi_font_frames[i]:SetVisible(false)
            mkbi_font_text_frames[i]:SetVisible(false)
        end
        mkbi_font_menu_open = false
    else
        mkbi_font_dropbox:SetTexture("MontsKBIndicator","down_arrow_selected.jpg")
        if table.maxn(mkbi_font_frames) == 0 then
            -- Create frames for the font drop down menu
            --for mkbi_check,mkbi_what in MontsKBIndicator.SortTableByKey(mkbi_fonts) do
            --    print(mkbi_check,mkbi_what)
            --end
            local mkbi_frame_count = 1
            for mkbi_file,mkbi_name in MontsKBIndicator.SortTableByKey(mkbi_fonts) do
                mkbi_font_frames[mkbi_frame_count] = UI.CreateFrame("Frame","Font Text Frame",mkbi_ui)
                mkbi_font_frames[mkbi_frame_count]:SetLayer(6)
                mkbi_font_frames[mkbi_frame_count]:SetHeight(20)
                mkbi_font_frames[mkbi_frame_count]:SetWidth(mkbi_font_selector:GetWidth())
                mkbi_font_frames[mkbi_frame_count]:SetBackgroundColor(0,0,0,1)
                mkbi_font_frames[mkbi_frame_count]:SetPoint("TOPLEFT",mkbi_font_selector,"TOPLEFT",0,mkbi_font_selector:GetHeight()+(mkbi_frame_count-1)*mkbi_font_frames[mkbi_frame_count]:GetHeight())
                mkbi_font_frames[mkbi_frame_count]:SetVisible(true)
                mkbi_font_frames[mkbi_frame_count]:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.FontChange(mkbi_file) end,"Font Has Changed")
                
                mkbi_font_text_frames[mkbi_frame_count] = UI.CreateFrame("Text","Font Text",mkbi_ui)
                mkbi_font_text_frames[mkbi_frame_count]:SetLayer(7)
                mkbi_font_text_frames[mkbi_frame_count]:SetFontColor(1,1,1,1)
                mkbi_font_text_frames[mkbi_frame_count]:SetText(mkbi_name)
                mkbi_font_text_frames[mkbi_frame_count]:SetPoint("CENTER",mkbi_font_frames[mkbi_frame_count],"CENTER",0,0)
                mkbi_font_text_frames[mkbi_frame_count]:SetVisible(true)
                mkbi_frame_count = mkbi_frame_count+1
            end
        else
            for i=1,table.maxn(mkbi_font_frames),1 do
                mkbi_font_frames[i]:SetVisible(true)
                mkbi_font_text_frames[i]:SetVisible(true)
            end
        end
        mkbi_font_menu_open = true
    end
end


-- Currently sorting, but not quite all the way.  Most likely issue with capitialization in filenames.
function MontsKBIndicator.SortTableByKey(mkbi_table)
    --sortarray used to sort values
    --temparray used to return filenames back after converting to uppercase to prevent sorting issues
    local mkbi_sortarray = {}
    local mkbi_temparray = {}
    for mkbi_key in pairs(mkbi_table) do
        table.insert(mkbi_temparray,mkbi_key)
        table.insert(mkbi_sortarray,string.upper(mkbi_key))
    end
    table.sort(mkbi_sortarray)
    -- Set filenames back to original value
    for i=1,table.maxn(mkbi_temparray),1 do
        for j=1,table.maxn(mkbi_sortarray),1 do
            if string.upper(mkbi_temparray[i]) == mkbi_sortarray[j] then
                mkbi_sortarray[j] = mkbi_temparray[i]
            end
        end
    end
    local mkbi_i = 0
    local mkbi_iter = function ()
            mkbi_i = mkbi_i +1
            if mkbi_sortarray[mkbi_i] == nil then
                return nil
            else
                return mkbi_sortarray[mkbi_i],mkbi_table[mkbi_sortarray[mkbi_i]]
            end
        end
    return mkbi_iter
    --mkbi_table = mkbi_temparray
    --dump(mkbi_temparray)
end

-- Pass in a filename and rebuild the UI text to show the change
function MontsKBIndicator.FontChange(mkbi_fontfile)
	if mkbi_current_tab == "killing blow" then
		MKBISave.font = "Fonts/" .. mkbi_fontfile .. ".ttf"
	elseif mkbi_current_tab == "saves" then
		MKBISave.savefont = "Fonts/" .. mkbi_fontfile .. ".ttf"
	elseif mkbi_current_tab == "accolades" then
		
	end
    MontsKBIndicator.ClearAllUIText()
    MontsKBIndicator.BuildUIText()
    for i=1,table.maxn(mkbi_font_frames),1 do
        mkbi_font_frames[i]:SetVisible(false)
        mkbi_font_text_frames[i]:SetVisible(false)
    end
    mkbi_font_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
    mkbi_font_menu_open = false
   -- print(MKBISave.font)
    -- Extract filename from MKBISave.font and use it to find the element in mkbi_fonts
    local mkbi_filename_text = ""
    if mkbi_current_tab == "killing blow" then
		mkbi_filename_text,_ = string.gsub(MKBISave.font,".ttf","")
	elseif mkbi_current_tab == "saves" then
		mkbi_filename_text,_ = string.gsub(MKBISave.savefont,".ttf","")
	elseif mkbi_current_tab == "accolades" then
		
	end
    mkbi_filename_text,_ = string.gsub(mkbi_filename_text,"Fonts/","")
    for mkbi_fontfile,mkbi_text_toset in pairs(mkbi_fonts) do
        if mkbi_fontfile == mkbi_filename_text then
            mkbi_filename_text = mkbi_text_toset
            break
        end
    end
    mkbi_font_sel_text:SetText(mkbi_filename_text)
end

function MontsKBIndicator.TextfieldMenuHandler()
    -- If the Font menu is open close it
    if mkbi_font_menu_open then
        mkbi_font_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
        for i=1,table.maxn(mkbi_font_frames),1 do
            mkbi_font_frames[i]:SetVisible(false)
            mkbi_font_text_frames[i]:SetVisible(false)
        end
    end
    mkbi_font_menu_open = false
    -- Textfield Menu Handler
    if mkbi_textfield_menu_open then
        mkbi_textfield_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
        for i=1,table.maxn(mkbi_textfield_frames),1 do
            mkbi_textfield_frames[i]:SetVisible(false)
            mkbi_textfield_text_frames[i]:SetVisible(false)
        end
        mkbi_textfield_menu_open = false
    else
        mkbi_textfield_dropbox:SetTexture("MontsKBIndicator","down_arrow_selected.jpg")
        if table.maxn(mkbi_textfield_frames) == 0 then
			local mkbi_temp_textfields = nil
			if mkbi_current_tab == "killing blow" then
				mkbi_temp_textfields = mkbi_textfields
			elseif mkbi_current_tab == "saves" then
				mkbi_temp_textfields = mkbi_save_textfields
			elseif mkbi_current_tab == "accolades" then
			
			end
            for i=1,table.maxn(mkbi_temp_textfields),1 do
                mkbi_textfield_frames[i] = UI.CreateFrame("Frame","Textfield Menu Frames",mkbi_ui)
                mkbi_textfield_frames[i]:SetLayer(4)
                mkbi_textfield_frames[i]:SetWidth(mkbi_textfield_selector:GetWidth())
                mkbi_textfield_frames[i]:SetHeight(mkbi_textfield_selector:GetHeight())
                mkbi_textfield_frames[i]:SetBackgroundColor(0,0,0,1)
                mkbi_textfield_frames[i]:SetPoint("TOPLEFT",mkbi_textfield_selector,"TOPLEFT",0,mkbi_textfield_selector:GetHeight()+(i-1)*mkbi_textfield_frames[i]:GetHeight())
                mkbi_textfield_frames[i]:SetVisible(true)
                mkbi_textfield_frames[i]:EventAttach(Event.UI.Input.Mouse.Left.Click,function() MontsKBIndicator.TextfieldChange(mkbi_textfields[i]) end,"Textfield To Edit Has Changed")
                
                mkbi_textfield_text_frames[i] = UI.CreateFrame("Text","Textfield Menu Text",mkbi_ui)
                mkbi_textfield_text_frames[i]:SetLayer(5)
                mkbi_textfield_text_frames[i]:SetFontColor(1,1,1,1)
                mkbi_textfield_text_frames[i]:SetText(mkbi_textfields[i])
                mkbi_textfield_text_frames[i]:SetPoint("CENTER",mkbi_textfield_frames[i],"CENTER",0,0)
                mkbi_textfield_text_frames[i]:SetVisible(true)
            end
        else
            for i=1,table.maxn(mkbi_textfield_frames),1 do
                mkbi_textfield_frames[i]:SetVisible(true)
                mkbi_textfield_text_frames[i]:SetVisible(true)
            end
        end
        mkbi_textfield_menu_open = true
    end
end

function MontsKBIndicator.TextfieldChange(mkbi_textfield)
    mkbi_textfield_text:SetText(mkbi_textfield)
    mkbi_current_textfield = mkbi_textfield
    mkbi_textfield_dropbox:SetTexture("MontsKBIndicator","down_arrow_unselected.jpg")
    for i=1,table.maxn(mkbi_textfield_frames),1 do
        mkbi_textfield_frames[i]:SetVisible(false)
        mkbi_textfield_text_frames[i]:SetVisible(false)
    end
    mkbi_textfield_menu_open = false
    
    --ONCE THE FRAMES ARE MADE ADD LOADING VALUES FOR FONT SIZE AND COLOR HERE!!!!!!!!!!!!!!!!!!!
    local mkbi_scrollbar_workaround = 0
    local mkbi_red_scrollbar_fix = 0
    local mkbi_blue_scrollbar_fix = 0
    local mkbi_green_scrollbar_fix = 0
    if mkbi_current_textfield == "Main" then
		if mkbi_current_tab == "killing blow" then
			mkbi_scrollbar_workaround = MKBISave.mainsize
			mkbi_red_scrollbar_fix = MKBISave.mainred*255
			mkbi_blue_scrollbar_fix = MKBISave.mainblue*255
			mkbi_green_scrollbar_fix = MKBISave.maingreen*255
		elseif mkbi_current_tab == "saves" then
			mkbi_scrollbar_workaround = MKBISave.savemainsize
			mkbi_red_scrollbar_fix = MKBISave.savemainred*255
			mkbi_blue_scrollbar_fix = MKBISave.savemainblue*255
			mkbi_green_scrollbar_fix = MKBISave.savemaingreen*255
		elseif mkbi_current_tab == "accolades" then
			
		end
    elseif mkbi_current_textfield == "Name" then
		if mkbi_current_tab == "killing blow" then
			mkbi_scrollbar_workaround = MKBISave.namesize
        mkbi_red_scrollbar_fix = MKBISave.namered*255
        mkbi_blue_scrollbar_fix = MKBISave.nameblue*255
        mkbi_green_scrollbar_fix = MKBISave.namegreen*255
		elseif mkbi_current_tab == "saves" then
			mkbi_scrollbar_workaround = MKBISave.savenamesize
        mkbi_red_scrollbar_fix = MKBISave.savenamered*255
        mkbi_blue_scrollbar_fix = MKBISave.savenameblue*255
        mkbi_green_scrollbar_fix = MKBISave.savenamegreen*255
		elseif mkbi_current_tab == "accolades" then
			
		end
    elseif mkbi_current_textfield == "XP" then
        mkbi_scrollbar_workaround = MKBISave.xpsize
        mkbi_red_scrollbar_fix = MKBISave.xpred*255
        mkbi_blue_scrollbar_fix = MKBISave.xpblue*255
        mkbi_green_scrollbar_fix = MKBISave.xpgreen*255
    elseif mkbi_current_textfield == "PA XP" then
        mkbi_scrollbar_workaround = MKBISave.pasize
        mkbi_red_scrollbar_fix = MKBISave.pared*255
        mkbi_blue_scrollbar_fix = MKBISave.pablue*255
        mkbi_green_scrollbar_fix = MKBISave.pagreen*255
    elseif mkbi_current_textfield == "Favor" then
        mkbi_scrollbar_workaround = MKBISave.favsize
        mkbi_red_scrollbar_fix = MKBISave.favred*255
        mkbi_blue_scrollbar_fix = MKBISave.favblue*255
        mkbi_green_scrollbar_fix = MKBISave.favgreen*255
    elseif mkbi_current_textfield == "Prestige" then
        mkbi_scrollbar_workaround = MKBISave.pressize
        mkbi_red_scrollbar_fix = MKBISave.presred*255
        mkbi_blue_scrollbar_fix = MKBISave.presblue*255
        mkbi_green_scrollbar_fix = MKBISave.presgreen*255
    else
        print("Error: Attempted to set size on unknown Textfield!")
    end
    mkbi_text_size_scroll:SetPosition(mkbi_scrollbar_workaround)
    mkbi_text_red_scroll:SetPosition(mkbi_red_scrollbar_fix)
    mkbi_text_green_scroll:SetPosition(mkbi_green_scrollbar_fix)
    mkbi_text_blue_scroll:SetPosition(mkbi_blue_scrollbar_fix)
    
end

function MontsKBIndicator.SizeScrollbarHandler()
    local mkbi_scroll_change = mkbi_text_size_scroll:GetPosition()
    local mkbi_scroll_rem = 0
    mkbi_scroll_change,_ = math.modf(mkbi_scroll_change)
	if mkbi_current_tab == "killing blow" then
		if mkbi_current_textfield == "Main" then
			MKBISave.mainsize = mkbi_scroll_change
		elseif mkbi_current_textfield == "Name" then
			MKBISave.namesize = mkbi_scroll_change
		elseif mkbi_current_textfield == "XP" then
			MKBISave.xpsize = mkbi_scroll_change
		elseif mkbi_current_textfield == "PA XP" then
			MKBISave.pasize = mkbi_scroll_change
		elseif mkbi_current_textfield == "Favor" then
			MKBISave.favsize = mkbi_scroll_change
		elseif mkbi_current_textfield == "Prestige" then
			MKBISave.pressize = mkbi_scroll_change
		else
			print("Error: Attempted to set size on unknown Textfield!")
		end
	elseif mkbi_current_tab == "saves" then
		if mkbi_current_textfield == "Main" then
			MKBISave.savemainsize = mkbi_scroll_change
		elseif mkbi_current_textfield == "Name" then
			MKBISave.savenamesize = mkbi_scroll_change
		else
			print("Error: Attempted to set size on unknown Textfield!")
		end
	elseif mkbi_current_tab == "accolades" then
		
	end
    mkbi_text_edit_size:SetText(string.sub(tostring(mkbi_scroll_change),1,4))
    MontsKBIndicator.ClearAllUIText()
    MontsKBIndicator.BuildUIText()
end

function MontsKBIndicator.RedScrollbarHandler()
    local mkbi_scroll_change = mkbi_text_red_scroll:GetPosition()
    mkbi_scroll_change,_ = math.modf(mkbi_scroll_change)
    if mkbi_current_tab == "killing blow" then
		if mkbi_current_textfield == "Main" then
			MKBISave.mainred = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Name" then
			MKBISave.namered = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "XP" then
			MKBISave.xpred = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "PA XP" then
			MKBISave.pared = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Favor" then
			MKBISave.favred = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Prestige" then
			MKBISave.presred = mkbi_scroll_change/255
		else
			print("Error: Attempted to set color on unknown Textfield!")
		end
	elseif mkbi_current_tab == "saves" then
		if mkbi_current_textfield == "Main" then
			MKBISave.savemainred = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Name" then
			MKBISave.savenamered = mkbi_scroll_change/255
		else
			print("Error: Attempted to set color on unknown Textfield!")
		end
	elseif mkbi_current_tab == "accolades" then
			
	end
    mkbi_text_edit_red:SetText(tostring(mkbi_scroll_change))
    MontsKBIndicator.ClearAllUIText()
    MontsKBIndicator.BuildUIText()
end

function MontsKBIndicator.GreenScrollbarHandler()
    local mkbi_scroll_change = mkbi_text_green_scroll:GetPosition()
    mkbi_scroll_change,_ = math.modf(mkbi_scroll_change)
    if mkbi_current_tab == "killing blow" then
		if mkbi_current_textfield == "Main" then
			MKBISave.maingreen = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Name" then
			MKBISave.namegreen = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "XP" then
			MKBISave.xpgreen = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "PA XP" then
			MKBISave.pagreen = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Favor" then
			MKBISave.favgreen = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Prestige" then
			MKBISave.presgreen = mkbi_scroll_change/255
		else
			print("Error: Attempted to set color on unknown Textfield!")
		end
	elseif mkbi_current_tab == "saves" then
		if mkbi_current_textfield == "Main" then
			MKBISave.savemaingreen = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Name" then
			MKBISave.savenamegreen = mkbi_scroll_change/255
		else
			print("Error: Attempted to set color on unknown Textfield!")
		end
	elseif mkbi_current_tab == "accolades" then
			
	end
    mkbi_text_edit_green:SetText(tostring(mkbi_scroll_change))
    MontsKBIndicator.ClearAllUIText()
    MontsKBIndicator.BuildUIText()
end

function MontsKBIndicator.BlueScrollbarHandler()
    local mkbi_scroll_change = mkbi_text_blue_scroll:GetPosition()
    mkbi_scroll_change,_ = math.modf(mkbi_scroll_change)
    if mkbi_current_tab == "killing blow" then
		if mkbi_current_textfield == "Main" then
			MKBISave.mainblue = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Name" then
			MKBISave.nameblue = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "XP" then
			MKBISave.xpblue = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "PA XP" then
			MKBISave.pablue = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Favor" then
			MKBISave.favblue = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Prestige" then
			MKBISave.presblue = mkbi_scroll_change/255
		else
			print("Error: Attempted to set color on unknown Textfield!")
		end
	elseif mkbi_current_tab == "saves" then
		if mkbi_current_textfield == "Main" then
			MKBISave.savemainblue = mkbi_scroll_change/255
		elseif mkbi_current_textfield == "Name" then
			MKBISave.savenameblue = mkbi_scroll_change/255
		else
			print("Error: Attempted to set color on unknown Textfield!")
		end
	elseif mkbi_current_tab == "accolades" then
			
	end
    mkbi_text_edit_blue:SetText(tostring(mkbi_scroll_change))
    MontsKBIndicator.ClearAllUIText()
    MontsKBIndicator.BuildUIText()
end

function MontsKBIndicator.SizeTextHandler()
    local mkbi_num_text = mkbi_text_edit_size:GetText()
    if mkbi_num_text == "" then
        return
    end
    mkbi_num_text = string.match(mkbi_num_text,"[0-9]+")
    mkbi_num_text= tonumber(mkbi_num_text)
	if (mkbi_num_text <= 50) and (mkbi_num_text >= 10) then
		if mkbi_current_tab == "killing blow" then
			if mkbi_current_textfield == "Main" then
				MKBISave.mainsize = mkbi_num_text
			elseif mkbi_current_textfield == "Name" then
				MKBISave.namesize = mkbi_num_text
			elseif mkbi_current_textfield == "XP" then
				MKBISave.xpsize = mkbi_num_text
			elseif mkbi_current_textfield == "PA XP" then
				MKBISave.pasize = mkbi_num_text
			elseif mkbi_current_textfield == "Favor" then
				MKBISave.favsize = mkbi_num_text
			elseif mkbi_current_textfield == "Prestige" then
				MKBISave.pressize = mkbi_num_text
			else
				print("Error: Attempted to set size on unknown Textfield!")
			end
		elseif mkbi_current_tab == "saves" then
			if mkbi_current_textfield == "Main" then
				MKBISave.savemainsize = mkbi_num_text
			elseif mkbi_current_textfield == "Name" then
				MKBISave.savenamesize = mkbi_num_text
			else
				print("Error: Attempted to set size on unknown Textfield!")
			end
		elseif mkbi_current_tab == "accolades" then
				
		end
        mkbi_text_size_scroll:SetPosition(mkbi_num_text)
    end
end

function MontsKBIndicator.RedTextHandler()
    local mkbi_num_text = mkbi_text_edit_red:GetText()
    if mkbi_num_text == "" then
        return
    end
    mkbi_num_text = string.match(mkbi_num_text,"[0-9]+")
    mkbi_num_text= tonumber(mkbi_num_text)
    if (mkbi_num_text <= 255) and (mkbi_num_text >= 0) then
		if mkbi_current_tab == "killing blow" then
			if mkbi_current_textfield == "Main" then
            MKBISave.mainred = mkbi_num_text/255
        elseif mkbi_current_textfield == "Name" then
            MKBISave.namered = mkbi_num_text/255
        elseif mkbi_current_textfield == "XP" then
            MKBISave.xpred = mkbi_num_text/255
        elseif mkbi_current_textfield == "PA XP" then
            MKBISave.pared = mkbi_num_text/255
        elseif mkbi_current_textfield == "Favor" then
            MKBISave.favred = mkbi_num_text/255
        elseif mkbi_current_textfield == "Prestige" then
            MKBISave.presred = mkbi_num_text/255
        else
            print("Error: Attempted to set color on unknown Textfield!")
        end
		elseif mkbi_current_tab == "saves" then
			if mkbi_current_textfield == "Main" then
            MKBISave.savemainred = mkbi_num_text/255
        elseif mkbi_current_textfield == "Name" then
            MKBISave.savenamered = mkbi_num_text/255
        else
            print("Error: Attempted to set color on unknown Textfield!")
        end
		elseif mkbi_current_tab == "accolades" then
			
		end
        mkbi_text_red_scroll:SetPosition(mkbi_num_text)
    end
end

function MontsKBIndicator.GreenTextHandler()
    local mkbi_num_text = mkbi_text_edit_green:GetText()
    if mkbi_num_text == "" then
        return
    end
    mkbi_num_text = string.match(mkbi_num_text,"[0-9]+")
    mkbi_num_text= tonumber(mkbi_num_text)
    if (mkbi_num_text <= 255) and (mkbi_num_text >= 0) then
		if mkbi_current_tab == "killing blow" then
			if mkbi_current_textfield == "Main" then
            MKBISave.maingreen = mkbi_num_text/255
        elseif mkbi_current_textfield == "Name" then
            MKBISave.namegreen = mkbi_num_text/255
        elseif mkbi_current_textfield == "XP" then
            MKBISave.xpgreen = mkbi_num_text/255
        elseif mkbi_current_textfield == "PA XP" then
            MKBISave.pagreen = mkbi_num_text/255
        elseif mkbi_current_textfield == "Favor" then
            MKBISave.favgreen = mkbi_num_text/255
        elseif mkbi_current_textfield == "Prestige" then
            MKBISave.presgreen = mkbi_num_text/255
        else
            print("Error: Attempted to set color on unknown Textfield!")
        end
		elseif mkbi_current_tab == "saves" then
			if mkbi_current_textfield == "Main" then
            MKBISave.savemaingreen = mkbi_num_text/255
        elseif mkbi_current_textfield == "Name" then
            MKBISave.savenamegreen = mkbi_num_text/255
        else
            print("Error: Attempted to set color on unknown Textfield!")
        end
		elseif mkbi_current_tab == "accolades" then
				
		end
        mkbi_text_green_scroll:SetPosition(mkbi_num_text)
    end
end

function MontsKBIndicator.BlueTextHandler()
    local mkbi_num_text = mkbi_text_edit_blue:GetText()
    if mkbi_num_text == "" then
        return
    end
    mkbi_num_text = string.match(mkbi_num_text,"[0-9]+")
    mkbi_num_text= tonumber(mkbi_num_text)
    if (mkbi_num_text <= 255) and (mkbi_num_text >= 0) then
		if mkbi_current_tab == "killing blow" then
			if mkbi_current_textfield == "Main" then
				MKBISave.mainblue = mkbi_num_text/255
			elseif mkbi_current_textfield == "Name" then
				MKBISave.nameblue = mkbi_num_text/255
			elseif mkbi_current_textfield == "XP" then
				MKBISave.xpblue = mkbi_num_text/255
			elseif mkbi_current_textfield == "PA XP" then
				MKBISave.pablue = mkbi_num_text/255
			elseif mkbi_current_textfield == "Favor" then
				MKBISave.favblue = mkbi_num_text/255
			elseif mkbi_current_textfield == "Prestige" then
				MKBISave.presblue = mkbi_num_text/255
			else
				print("Error: Attempted to set color on unknown Textfield!")
			end
		elseif mkbi_current_tab == "saves" then
			if mkbi_current_textfield == "Main" then
				MKBISave.savemainblue = mkbi_num_text/255
			elseif mkbi_current_textfield == "Name" then
				MKBISave.savenameblue = mkbi_num_text/255
			else
				print("Error: Attempted to set color on unknown Textfield!")
			end
		elseif mkbi_current_tab == "accolades" then
				
		end
        mkbi_text_blue_scroll:SetPosition(mkbi_num_text)
    end
end

function MontsKBIndicator.TabHandler(mkbi_tab)
	--print(mkbi_tab:GetName())
	if mkbi_tab:GetName() == "Killing Blow Tab" then
		mkbi_current_tab = "killing blow"
		mkbi_kb_tab_text:SetEffectGlow({blurX = 10, blurY = 10,strength = 5})
		mkbi_save_tab_text:SetEffectGlow(nil)
		mkbi_accolade_tab_text:SetEffectGlow(nil)
		
		mkbi_xptext_edit:SetVisible(true)
		mkbi_patext_edit:SetVisible(true)
		mkbi_favor_edit:SetVisible(true)
		mkbi_prestige_edit:SetVisible(true)
		mkbi_textfield_frames = {}
	elseif mkbi_tab:GetName() == "Save Tab" then
		mkbi_current_tab = "saves"
		mkbi_kb_tab_text:SetEffectGlow(nil)
		mkbi_save_tab_text:SetEffectGlow({blurX = 10, blurY = 10,strength = 5})
		mkbi_accolade_tab_text:SetEffectGlow(nil)
		mkbi_textfield_frames = {}
	elseif mkbi_tab:GetName() == "Accolade Tab" then
		mkbi_current_tab = "accolades"
		mkbi_kb_tab_text:SetEffectGlow(nil)
		mkbi_save_tab_text:SetEffectGlow(nil)
		mkbi_accolade_tab_text:SetEffectGlow({blurX = 10, blurY = 10,strength = 5})
	end
	MontsKBIndicator.ClearAllUIText()
	MontsKBIndicator.BuildUIText()
	MontsKBIndicator.ResetUI()
	
end

function MontsKBIndicator.ClearAllUIText()
    mkbi_textframe_edit:ClearAll()
    mkbi_nametext_edit:ClearAll()
    mkbi_xptext_edit:ClearAll()
    mkbi_patext_edit:ClearAll()
    mkbi_favor_edit:ClearAll()
    mkbi_prestige_edit:ClearAll()
end

function MontsKBIndicator.ResetUI()
	mkbi_textfield_text:SetText("Main")
	mkbi_current_textfield = "Main"
	
	local mkbi_size_scrollbar_reset_fix = 0
	local mkbi_red_scrollbar_fix = 0
	local mkbi_green_scrollbar_fix = 0
	local mkbi_blue_scrollbar_fix = 0
	if mkbi_current_tab == "killing blow" then
		mkbi_size_scrollbar_reset_fix = MKBISave.mainsize
		mkbi_text_size_scroll:SetRange(10,50)
		mkbi_text_size_scroll:SetPosition(mkbi_size_scrollbar_reset_fix)
		
		mkbi_red_scrollbar_fix = MKBISave.mainred
		mkbi_text_red_scroll:SetRange(0,255)
		mkbi_text_red_scroll:SetPosition(mkbi_red_scrollbar_fix*255)
		
		mkbi_green_scrollbar_fix = MKBISave.maingreen
		mkbi_text_green_scroll:SetRange(0,255)
		mkbi_text_green_scroll:SetPosition(mkbi_green_scrollbar_fix*255)
		
		mkbi_blue_scrollbar_fix = MKBISave.mainblue
		mkbi_text_blue_scroll:SetRange(0,255)
		mkbi_text_blue_scroll:SetPosition(mkbi_blue_scrollbar_fix*255)
	elseif mkbi_current_tab == "saves" then
		mkbi_size_scrollbar_reset_fix = MKBISave.savemainsize
		mkbi_text_size_scroll:SetRange(10,50)
		mkbi_text_size_scroll:SetPosition(mkbi_size_scrollbar_reset_fix)
		
		mkbi_red_scrollbar_fix = MKBISave.savemainred
		mkbi_text_red_scroll:SetRange(0,255)
		mkbi_text_red_scroll:SetPosition(mkbi_red_scrollbar_fix*255)
		
		mkbi_green_scrollbar_fix = MKBISave.savemaingreen
		mkbi_text_green_scroll:SetRange(0,255)
		mkbi_text_green_scroll:SetPosition(mkbi_green_scrollbar_fix*255)
		
		mkbi_blue_scrollbar_fix = MKBISave.savemainblue
		mkbi_text_blue_scroll:SetRange(0,255)
		mkbi_text_blue_scroll:SetPosition(mkbi_blue_scrollbar_fix*255)
	elseif mkbi_current_tab == "accolades" then
			
	end
	
	local mkbi_filename_text = ""
    if mkbi_current_tab == "killing blow" then
		mkbi_filename_text,_ = string.gsub(MKBISave.font,".ttf","")
	elseif mkbi_current_tab == "saves" then
		mkbi_filename_text,_ = string.gsub(MKBISave.savefont,".ttf","")
	elseif mkbi_current_tab == "accolades" then
		
	end
    mkbi_filename_text,_ = string.gsub(mkbi_filename_text,"Fonts/","")
    for mkbi_fontfile,mkbi_text_toset in pairs(mkbi_fonts) do
        if mkbi_fontfile == mkbi_filename_text then
            mkbi_filename_text = mkbi_text_toset
            break
        end
    end
    mkbi_font_sel_text:SetText(mkbi_filename_text)
    
    for i=1,table.maxn(mkbi_font_frames),1 do
        mkbi_font_frames[i]:SetVisible(false)
        mkbi_font_text_frames[i]:SetVisible(false)
    end
    for i=1,table.maxn(mkbi_textfield_frames),1 do
        mkbi_textfield_frames[i]:SetVisible(false)
        mkbi_textfield_text_frames[i]:SetVisible(false)
    end
end

function MontsKBIndicator.ResetToDefault()
    local mkbi_button_x_default = UIParent:GetWidth()/2
    local mkbi_button_y_default = UIParent:GetHeight()/2
    MKBISave = {
        x = 100,
        y = 100,
        font = "Fonts/Cas_antn.ttf",
        mainsize = 15,
        namesize = 35,
        xpsize = 17,
        pasize = 17,
        favsize = 17,
        pressize = 17,
        mainred = 1,
        maingreen = 1,
        mainblue = 0,
        namered = 1,
        namegreen = 0,
        nameblue = 0,
        xpred = 0.8,
        xpgreen = 0.8,
        xpblue = 0,
        pared = 0.2,
        pagreen = 1,
        pablue = 0.2,
        favred = 0.8,
        favgreen = 0,
        favblue = 0.8,
        presred = 0.2,
        presgreen = 0.2,
        presblue = 1,
        alpha = 1,
        uptime = 5,
        specialmsg = false,
        buttonx = mkbi_button_x_default,
        buttony = mkbi_button_y_default,
        editx = 100,
        edity = 100,
        enable_saves = true,
        savemainred = 0,
		savemaingreen = 0.7,
		savemainblue = 0,
		savemainsize = 15,
		savenamered = 0.7,
		savenamegreen = 0.7,
		savenameblue = 0,
		savenamesize = 35,
		savealpha = 1,
		savefont = "Fonts/Cas_antn.ttf",
		savex = 400,
		savey = 400

    }
    --MontsKBIndicator.BuildEditUI()
    MontsKBIndicator.TextfieldChange("Main")
    mkbi_specmsg_chbox:SetChecked(false)
    mkbi_edit_button:SetPoint("CENTER",mkbi_ui,"CENTER",mkbi_button_x_default,mkbi_button_y_default)
end

function  MontsKBIndicator.SpecialMsgCheckboxHandler()
    local mkbi_spcmsg = mkbi_specmsg_chbox:GetChecked()
    MKBISave.specialmsg = mkbi_spcmsg
end

function MontsKBIndicator.EnableSavesCheckboxHandler()
    local mkbi_enabledchkbox = mkbi_save_chbox:GetChecked()
    MKBISave.enable_saves = mkbi_enabledchkbox
end

function MontsKBIndicator.MoveButtonHandler()
	local mkbi_curr_vis = false
	if mkbi_current_tab == "killing blow" then
		mkbi_curr_vis = mkbi_moveframe:GetVisible()
		MontsKBIndicator.EditUIHide()
		MontsKBIndicator.ShowKBText()
		mkbi_moveframe:SetWidth(mkbi_textframe:GetWidth())
		mkbi_moveframe:SetHeight(mkbi_prestige:GetBottom() - mkbi_textframe:GetTop())
		if mkbi_curr_vis then
			mkbi_moveframe:SetVisible(false)
			mkbi_moveable = false
		else
			mkbi_moveframe:SetVisible(true)
			mkbi_moveable = true
		end
	elseif mkbi_current_tab == "saves" then
		mkbi_curr_vis = mkbi_savemoveframe:GetVisible()
		MontsKBIndicator.EditUIHide()
		MontsKBIndicator.ShowSaveText("Thatguy@Server")
		mkbi_moveframe:SetWidth(mkbi_textframe:GetWidth())
		mkbi_moveframe:SetHeight(mkbi_savename:GetBottom() - mkbi_saveframe:GetTop())
		if mkbi_curr_vis then
			mkbi_savemoveframe:SetVisible(false)
			mkbi_moveable = false
		else
			mkbi_savemoveframe:SetVisible(true)
			mkbi_moveable = true
		end
	elseif mkbi_current_tab == "accolades" then
			
	end
end

function MontsKBIndicator.UpTimeScrollHandler()
    local mkbi_new_uptime = mkbi_uptime_scroll:GetPosition()
    local mkbi_uptime_rem = 0
    mkbi_new_uptime,mkbi_uptime_rem = math.modf(mkbi_new_uptime)
    mkbi_uptime_rem = math.floor((mkbi_uptime_rem)*10)
    mkbi_uptime_rem = mkbi_uptime_rem/10
    mkbi_new_uptime = mkbi_new_uptime + mkbi_uptime_rem
    MKBISave.uptime = mkbi_new_uptime
    mkbi_uptime_edit:SetText(tostring(mkbi_new_uptime))
end

function MontsKBIndicator.UpTimeTextHandler()
    local mkbi_uptime_text = mkbi_uptime_edit:GetText()
    if mkbi_uptime_text == "" then
        return
    end
    mkbi_uptime_text = string.match(mkbi_uptime_text,"[0-9%.]+")
    mkbi_uptime_text= tonumber(mkbi_uptime_text)
    if (mkbi_uptime_text <= 15) and (mkbi_uptime_text >= 0.1) then
       MKBISave.uptime = mkbi_uptime_text
       mkbi_uptime_scroll:SetPosition(mkbi_uptime_text)
    end
end

function MontsKBIndicator.TestSettings()
    MontsKBIndicator.EditUIHide()
    if mkbi_current_tab == "killing blow" then
		MontsKBIndicator.ShowKBText()
		mkbi_starttime = Inspect.Time.Real()
	elseif mkbi_current_tab == "saves" then
		MontsKBIndicator.ShowSaveText("Thatguy@Server")
		mkbi_save_startime = Inspect.Time.Real()
	elseif mkbi_current_tab == "accolades" then
			
	end
    mkbi_currently_testing = true
end